__author__ = 'pav'
#------------------------------------------------------------------------------------
#       utils.helpers module:
#       Function's Suite for File I/O, Data Structures, Timestamp Transforms
#-------------------------------------------------------------------------------------

import os
from datetime import datetime
from time import mktime
from operator import itemgetter

#--------------------------------------------------------------------------------------
#                           GLOBAL VARS
#-------------------------------------------------------------------------------------
DATA_LOGS = os.path.expanduser("~\\Desktop\\Logs")
SQL_DUMPS = os.path.expanduser("~\\Desktop\\")

BOT_REPORT = """
\n
    Reporting Reporting %s images status:

        Total: images: %s

        unique GPS: %s
        unique Timestamp: %s
\n
"""

SERVER_PREFIX = "photos/"

REST_PREFIX = "http://95.85.57.196/get_last/"

QUERY = {
    'geoimage':""" INSERT INTO geotag_db_geoimage (id, img, timestamp, gps, next_image_id, prev_image_id, width, length, is_wide, region_id)
          VALUES ( '%s', '%s', '%s', ST_GeomFromText('POINT (%s)', 4326), %s, %s, 1920, 1080, '%s', '%s');""",
    'geovideo':""" INSERT INTO geotag_db_geovideo (id, video_id, image_id, time_to_play)
          VALUES ( %s, %s, %s, %s);""",
    'originvideo':""" INSERT INTO geotag_db_originvideo ( id, video, timestamp ) VALUES ('%s', '%s', 'not really care' ); """,
    'dump': """pg_dump %s > dump_file.txt""",
    'region': """ INSERT INTO geotag_db_region (id, name, date, description) VALUES ( '%s', '%s', '%s', '%s' );"""
}
#---------------------------------------------------------------------------------------
#                           File I/O utilities
#---------------------------------------------------------------------------------------

def getFiles(p):
    return [os.path.join(p, file) for file in os.listdir(p) if file != "Thumbs.db"]

def MkDir(p):
    if not os.path.exists(p): os.mkdir(p)


def DataLoad(*args, **kwargs):
    sock = open(kwargs["file"], "r")
    data_entries = [ line.rsplit("\n")[0].split("#") for line in sock]
    sock.close()
    return OrderListByValue(data_entries, -1)

def PathSanitizer(p):
    return SERVER_PREFIX + "/".join([ p.split("\\")[-3] , p.split("\\")[-1] ])

def PathLess(p):
    return "/".join(["data_files", p.split("\\")[-1]])

#-------------------------------------------------------s------------------------------
#                        Datetime Conversions and Transforms
#-------------------------------------------------------------------------------------


def DateToUnix(strformat):
    """
        Transform Datetime format to UNIX epoch time
    """
    date, time = strformat.split()
    ts = [int(i) for i in date.split("-")] + [int(i) for i in time.split(":")]
    ts = datetime(ts[0], ts[1], ts[2], ts[3], ts[4], ts[5])
    return int(mktime(ts.timetuple()))

def UnixToDate(unixformat):
    """
        Transform Unix epoch time to Datetime format
    """
    return datetime.fromtimestamp(int(unixformat)).strftime('%Y-%m-%d %H:%M:%S')



def MinuteToSec(duration):
    """
        Min-To-Sec Trans
    """
    h, m, sec = duration.split(":")
    return int(m)*60 + int(float(sec))


#-------------------------------------------------------------------------------------
#                       Data Structures Utilities, search, updates
#-------------------------------------------------------------------------------------

def OrderListByValue(obj, index):
    """
        Returns sorted list of lists by child list value - based on index
    """
    return sorted(obj, key=itemgetter(0,index))




#-------------------------------------------------------------------------------------
#                       Functional Test Area
#-------------------------------------------------------------------------------------

if __name__ == "__main__":
    print PathLess("C:\Users\pav\Desktop\Saronikos_6_Moni")