from __future__ import division
from datetime import datetime
import exifread
__author__ = 'pav'


def MetaReader(img):
    """
        Returns lat, lon, timestamp given a photo
    """
    f = open(img, 'rb')
    tags = exifread.process_file(f)

    tlon = tags['GPS GPSLongitude'].values
    tlat = tags['GPS GPSLatitude'].values
    h, m, s =  tags["GPS GPSTimeStamp"].values

    lon = tlon[0].num/tlon[0].den + tlon[1].num/tlon[1].den/60.0 + tlon[2].num/tlon[2].den/3600.0
    lat = tlat[0].num/tlat[0].den + tlat[1].num/tlat[1].den/60.0 + tlat[2].num/tlat[2].den/3600.0

    datum = "{} {}:{}:{}".format(tags["GPS GPSDate"],str(h), str(m),str(s))
    timestamp = datetime.strptime(datum, '%Y:%m:%d %I:%M:%S')

    return lat, lon, timestamp


if __name__ == '__main__':
    print MetaReader(r"c:\\Users\\pav\\Desktop\\test.jpg")